/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * tools.h - contem os prototipos de funcoes de auxilio geral dentro do GeoLab.
 *
 *           link flag (-lm)
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    31.10.91  13:45	Welson R. Jacometti	Arquivo Criado
 *
 */

#ifndef _TOOLS_DEFINED
#define _TOOLS_DEFINED

#include <math.h>
#include "global.h"

bool zero(double n, double tol = EPSLON);
CompType comp(double x, double y, double tol = EPSLON);
bool range(double v, double r1, double r2);
inline bool equal(double x, double y, double tol = EPSLON) { return zero(x - y, tol); }
inline bool less(double x, double y, double tol = EPSLON) { return x < (y - tol); }
inline bool greater(double x, double y, double tol = EPSLON) { return x > (y - tol); }
inline double min(double x, double y) { return x < y ? x : y; }
inline double max(double x, double y) { return x > y ? x : y; }
inline void swap(double &x, double &y) { double z = x; x = y; y = z; }
inline void regularize_coords(double &x1, double &y1, double &x2, double &y2) { if (x1 > x2) swap(x1, x2); if (y1 > y2) swap(y1, y2); }

#define Positive(X) ((X)>EPSLON)
#define Negative(X) ((X)<-EPSLON)
#define Zero(X) ((X)<=EPSLON && (X)>=-EPSLON)

#endif ~_TOOLS_DEFINED;
