/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti
                    Cesar N. Gon
                    Laerte F. Morgado

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

#ifndef CLOSEST_DEFINED
#define CLOSEST_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Segment2D.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

#ifndef _Segment2D_ptr_list
#define _Segment2D_ptr_list
declare(list,Segment2D_ptr)
#endif ~_Segment2D_ptr_list;


class Segment
{
  public:
    Segment2D_ptr s;
    double        l;
};

typedef Segment* Segment_ptr;


class ycell
{
  public:
    list_item    point;
    list_item    fellow;
    bool         selected;
};
typedef ycell* ycell_ptr;

class xcell
{
  public:
    list_item fellow;
};
typedef xcell* xcell_ptr;

declare(list,ycell_ptr);
declare(list,xcell_ptr);
     


class InternalClosestPairDC
{
  public:
    InternalClosestPairDC() {}
    ~InternalClosestPairDC();
    Segment_ptr find(list(Point2D_ptr)& points,World *w, int animation_depth, int reference_depth);
    
  private:
    
    list(xcell_ptr) XList;
    list(ycell_ptr) YList;

    
    void set(list(Point2D_ptr)& points);
    
    Segment_ptr RecursiveInternalClosestPairDC(list(xcell_ptr)& x,list(ycell_ptr)& y);
    
    void split(list(xcell_ptr)& x1,list(ycell_ptr)& y1,list(xcell_ptr)& x2,list(ycell_ptr)& y2);

    Segment_ptr select_min(Segment_ptr Seg1,Segment_ptr Seg2);

    
    void cut(list(ycell_ptr)& y,double b,double e);
    
    Segment_ptr GetMin(list(ycell_ptr)& P1, list(ycell_ptr)& P2,Segment_ptr Min1,double median,double delta,double sqrdelta);
    
    
    void copy(list(ycell_ptr)& s,list(ycell_ptr)& t);

    void kill_y_list(list(ycell_ptr)& it);
};

#endif CLOSEST_DEFINED;













