/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Intersections.h - mapeamento dos algoritmos para problemas de intersecao
 *                   implementados em intersections.C (.h)
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _INTERSECTIONS_CLASSES_DEFINED
#define _INTERSECTIONS_CLASSES_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"

class IntersectionProblems : public Algorithm {
  public:
    bool animation() { return true; }
};

class InterSegments : public IntersectionProblems {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};
  
class InterRays : public IntersectionProblems {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};
  
class InterLines : public IntersectionProblems {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};
  
class AllIntersectionsCountingBF : public InterSegments {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllIntersectionsReportBF : public InterSegments {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllIntersectionsRaysCountingBF : public InterRays {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllIntersectionsRaysReportBF : public InterRays {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllIntersectionsLinesCountingBF : public InterLines {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllIntersectionsLinesReportBF : public InterLines {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

Algorithm* all_intersections_counting_bf_link();
Algorithm* all_intersections_report_bf_link();
Algorithm* all_intersections_rays_counting_bf_link();
Algorithm* all_intersections_rays_report_bf_link();
Algorithm* all_intersections_lines_counting_bf_link();
Algorithm* all_intersections_lines_report_bf_link();

#endif ~_INTERSECTIONS_CLASSES_DEFINED;

