/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Line2D_test.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Welson	 	  	Arquivo criado
 *
 */

#ifndef _LINE2D_TEST_DEFINED
#define _LINE2D_TEST_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Line2D.h"

/*
 * algoritmos
 *
 */
 
bool intersect_line(Line2D_ptr &l1, Line2D_ptr &l2);
Point2D intersection_line(Line2D_ptr &l1, Line2D_ptr &l2); 

// Modelagem dos algoritmos acima em termos do ambiente GeoLab 

class Line2DTools : public Algorithm {
};

class intersect_lines : public Line2DTools {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class intersection_lines : public intersect_lines {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

Algorithm* intersect_lines_link();
Algorithm* intersection_lines_link();

#endif ~_LINE2D_TEST_DEFINED;




