/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * MinSpanningTree.h - mapeamento do algoritmo para construcao da Arvore
 *                     Euclidiana Espalhada Minima. Algoritmo retirado
 *                     da implementacao do LEDA para efeito de demonstracao.
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _MINSPANNINGTREE_DEFINED
#define _MINSPANNINGTREE_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "global.h"
#include "basic.h"
#include "Graph.h"
#include "SpanningTree.h"

SpanningTree_ptr min_spanning_tree(ugraph &G, edge_array(real) &cost, World *w = 0, int animation_depth = 0, int reference_depth = 0);

// modelagem

class EMST : public Algorithm {
  public:
    bool animation() { return true; }

    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);

    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
    
    Obj* instantiation(ObjType t);
};

Algorithm* emst_link();

#endif ~_MINSPANNINGTREE_DEFINED;
