/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * MiscClasses.h - mapeamento dos algoritmos interessantes de Misc.h (.C) em
 *                 algoritmos externos.
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _MISCCLASSES_DEFINED
#define _MISCCLASSES_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"

/*
 * Nota: os algoritmos mapeados aqui NECESSARIAMENTE devem prover algum tipo
 *       de animacao, por isso o default para algoritmos Misc e' retornar
 *       TRUE para animation().
 *
 */
 
class Misc : public Algorithm {
  public:
    bool animation() { return true; }
};

class MiscPoints : public Misc {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};
  
class LowerY : public MiscPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class LowerCCW : public MiscPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class MiscPolygon : public Misc {
};

class WindingNumber : public MiscPolygon {
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);

    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

Algorithm* lowerY_link();
Algorithm* lowerCCW_link();
Algorithm* winding_number_link();

#endif ~_MISCCLASSES_DEFINED;




