/*
    Copyright (C) 1992-1994
                    Cesar N. Gon

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Polygon_test.h
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Cesar N. Gon 	  	Arquivo criado
 *
 */

#ifndef _POLYGON_TEST_DEFINED
#define _POLYGON_TEST_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Segment2D.h"
#include "Polygon.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

#ifndef _Segment2D_ptr_list
#define _Segment2D_ptr_list
declare(list,Segment2D_ptr)
#endif ~_Segment2D_ptr_list;

/*
 * algoritmos
 *
 */
 
list(Point2D_ptr) get_polygon_points(Polygon_ptr P);
list(Segment2D_ptr) get_polygon_segments(Polygon_ptr P);

// Modelagem dos algoritmos acima em termos do ambiente GeoLab 

class PolygonTools : public Algorithm {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};

class get_points : public PolygonTools {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class get_segments : public PolygonTools {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class test_and_set_simple : public PolygonTools {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};

class test_and_set_convex : public PolygonTools {
  public:
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int);
};


Algorithm* get_points_link();
Algorithm* get_segments_link();
Algorithm* test_and_set_simple_link();
Algorithm* test_and_set_convex_link();

#endif ~_POLYGON_TEST_DEFINED;


