/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * Proximity.h - mapeamento dos algoritmos para problemas de proximidade
 *               implementados em proximity.C (.h)
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _PROXIMITY_CLASSES_DEFINED
#define _PROXIMITY_CLASSES_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"

class ProximityProblems : public Algorithm {
  public:
    bool animation() { return true; }
};

class ProxPoints : public ProximityProblems {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &);
};
  
class ClosestPairBF : public ProxPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllNearestNeighborsBF : public ProxPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class ClosestPairDC : public ProxPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllNearestNeighborsDC : public ProxPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class ClosestPairVD : public ProxPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

class AllNearestNeighborsVD : public ProxPoints {
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *w = 0, int animation_depth = 0, int reference_depth = 0);
};

Algorithm* closest_pair_bf_link();
Algorithm* all_nn_bf_link();
Algorithm* closest_pair_dc_link();
Algorithm* all_nn_dc_link();
Algorithm* closest_pair_vd_link();
Algorithm* all_nn_vd_link();

#endif ~_PROXIMITY_CLASSES_DEFINED;

