/*
    Copyright (C) 1992-1994
                    Laerte F. Morgado

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 *            Pslg_geotools.h: Modulo que contem a declaracao de algumas
 *                           ferramentas geometricas basicas.
 *
 *
 *            Laerte F. Morgado          01/03/91    arquivo criado.
 *
 *
 *
 */


#ifndef _Pslg_geotoolsDEFINED
#define _Pslg_geotoolsDEFINED

#include "global.h"


enum InterType { BOTH_CLOSED, BOTH_OPEN, FIRST_OPEN, SECOND_OPEN };



extern double planar_cross_product(double x1,double y1,double x2,double y2,double EPSON=1e-10);

extern double planar_dot_product(double x1,double y1,double x2,double y2,double EPSON=1e-10);

extern bool  left_side(double x,double y,double x1, double y1,double x2,double y2,double x3,double y3);

extern bool intersect( double x1,double y1, double x2,double y2, double x3,double y3, double x4, double y4,InterType mode1=BOTH_CLOSED,InterType mode2=BOTH_CLOSED);

extern double Theta(double x1, double y1, double x2, double y2);

#endif ~_Pslg_geotoolsDEFINED;



