/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * String.h - classe que implementa o tipo String, com facilidades extras
 *            para atribuicao, copia, comparacao, etc.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    19.11.91  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _STRING_DEFINED
#define _STRING_DEFINED

#include <string.h>
#include <iostream.h>
#include <assert.h>
#include <stdio.h>
#include "global.h"

class String {
  public:
    // constructor
    String() { len = 0; str = '\0'; }
    String(int);
    String(char *);
        
    // desctructor
    ~String() { delete str; }
  
    // assignment functions
    String(const String&);
    String& operator = (const String&);
    bool operator == (const String&) const;
    String operator + (const String&) const;
    
    int length() const { return len; }
    char *value() const { return str; }
    
  private:
    int len;
    char *str;
};

#endif ~_STRING_DEFINED;




