/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * boolean_example.h - exemplo de um algoritmo que produz um objeto "desconhecido"
 *                     pelo GeoLab (um valor booleano).
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.01.92  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _BOOLEAN_EXAMPLE_DEFINED
#define _BOOLEAN_EXAMPLE_DEFINED

#include "External.h"		// obrigatorio a todo modulo externo
#include "ExternalObj_id.h"
#include "Algorithm.h"
#include "Boolean.h"

Boolean* boolean();

// Modelagem do algoritmo acima em termos do ambiente GeoLab 

class boolean_example : public Algorithm {
  public:
    bool is_able_to_handle(const SelectedObjects &, const GraphicObjects &) {
    	return true;
    }
    
    ResultObjects binder(const SelectedObjects &, const GraphicObjects &, World *, int, int) {
        ResultObjects result;
        result.push(boolean());
        return result;
    }
    
    Obj* instantiation(ObjType t) {
        if (t == Boolean_t)
          return new Boolean();
        else
          return 0;
    }
};

Algorithm* boolean_link();

#endif ~_BOOLEAN_EXAMPLE_DEFINED




