/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * color.h - modulo de alocacao de cores do GeoLab. Conexao entre a interface
 *           e a aplicacao feita manualmente.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    12.12.91  08:45 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _COLOR_DEFINED
#define _COLOR_DEFINED

#include <iostream.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <xview/xview.h>
#include "global.h"

#define BLACK		0
#define GRAY		1
#define CYAN		2
#define BLUE		3
#define SIENNA		4
#define RED		5
#define MAGENTA	        6
#define YELLOW		7
#define ORANGE		8
#define SEAGREEN	9
#define DARKGREEN	10
#define GREEN		11
#define GOLDENROD	12
#define GOLD		13
#define KHAKI		14
#define WHITE		15

#define _BLACK		get_pixel_from_value(0)
#define _GRAY		get_pixel_from_value(1)
#define _CYAN		get_pixel_from_value(2)
#define _BLUE		get_pixel_from_value(3)
#define _SIENNA		get_pixel_from_value(4)
#define _RED		get_pixel_from_value(5)
#define _MAGENTA	get_pixel_from_value(6)
#define _YELLOW		get_pixel_from_value(7)
#define _ORANGE		get_pixel_from_value(8)
#define _SEA_GREEN	get_pixel_from_value(9)
#define _DARK_GREEN	get_pixel_from_value(10)
#define _GREEN		get_pixel_from_value(11)
#define _GOLDENROD	get_pixel_from_value(12)
#define _GOLD		get_pixel_from_value(13)
#define _KHAKI		get_pixel_from_value(14)
#define _WHITE		get_pixel_from_value(15)

#define NUM_COLORS	16

EXPORT unsigned long FOREGROUND;
EXPORT unsigned long BACKGROUND;
EXPORT bool SET_FOREGROUND;
EXPORT int SCREEN_DEPTH;

void init_colors(Xv_opaque win);
unsigned long get_pixel_from_value(int value);
int get_value_from_pixel(unsigned long pixel);

#endif ~_COLOR_DEFINED;




