/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * draw_arrow.h - implementacao de algoritmo externo para o desenho de
 *		  um tipo externo ao geolab (Arrow2D). Deve servir como
 *		  exemplo para outras implementacoes.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    20.02.92  13:40 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _DRAW_ARROW_DEFINED
#define _DRAW_ARROW_DEFINED

#include "External.h"
#include "Algorithm.h"
#include "Arrow2D.h"

class draw_arrow : public ExternalObjectMode {
  public:

    void activator(World *);
    
    icon_bits *icon();
     
    Obj* instantiation(ObjType t) {
    	if (t == Arrow2D_t)
          return new Arrow2D();
        else 
          return 0;
    }
};

Algorithm* draw_arrow_link();

#endif ~_DRAW_ARROW_DEFINED;






