/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * geolab_ui.h - contem a definicao da interface basica do GeoLab. 
 *		 Os componentes da interface sao definidos como 
 *               classes em C++
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    09.12.91  19:00 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _GEOLAB_UI_DEFINED
#define _GEOLAB_UI_DEFINED

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/icon_load.h>
#include <xview/panel.h>
#include <xview/scrollbar.h>
#include <xview/svrimage.h>
#include <xview/termsw.h>
#include <xview/text.h>
#include <xview/tty.h>
#include <xview/xv_xrect.h>
#include <gcm.h>
#include <assert.h>
#include "global.h"
#include "World.h"

extern Attr_attribute	INSTANCE;

Xv_opaque	geolab_menu_file_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_view_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_edit_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_input_tools_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_properties_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_random_points_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_random_cover_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_view_handles_toggle_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_random_polygon_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_algorithms_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_view_menu_layers_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_properties_menu_objects_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_properties_menu_debug_create(caddr_t *, Xv_opaque);
Xv_opaque	geolab_menu_external_modes_create(caddr_t *, Xv_opaque);

class geolab_geolab_base_window_objects {

public:
	Xv_opaque	geolab_base_window;
	Xv_opaque	controls_base_panel_horizontal;
	Xv_opaque	button_file;
	Xv_opaque	button_view;
	Xv_opaque	button_edit;
	Xv_opaque	button_properties;
	Xv_opaque	button_input_tools;
	Xv_opaque	button_algorithms;
	Xv_opaque	button_animation;
	Xv_opaque	button_compose;
	Xv_opaque	controls_base_panel_vertical;
	Xv_opaque	setting_mode;
	Xv_opaque	mouse_position_message;
	Xv_opaque	mouse_virtualXposition;
	Xv_opaque	const_message_virtualXposition_place_holder;
	Xv_opaque	mouse_virtualYposition;
	Xv_opaque	const_message_virtualYposition_place_holder;
	Xv_opaque	geolab_canvas;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	geolab_base_window_create(Xv_opaque);
	virtual Xv_opaque	controls_base_panel_horizontal_create(Xv_opaque);
	virtual Xv_opaque	button_file_create(Xv_opaque);
	virtual Xv_opaque	button_view_create(Xv_opaque);
	virtual Xv_opaque	button_edit_create(Xv_opaque);
	virtual Xv_opaque	button_properties_create(Xv_opaque);
	virtual Xv_opaque	button_input_tools_create(Xv_opaque);
	virtual Xv_opaque	button_algorithms_create(Xv_opaque);
	virtual Xv_opaque	button_animation_create(Xv_opaque);
	virtual Xv_opaque	button_compose_create(Xv_opaque);
	virtual Xv_opaque	controls_base_panel_vertical_create(Xv_opaque);
	virtual Xv_opaque	setting_mode_create(Xv_opaque);
	virtual Xv_opaque	mouse_position_message_create(Xv_opaque);
	virtual Xv_opaque	mouse_virtualXposition_create(Xv_opaque);
	virtual Xv_opaque	const_message_virtualXposition_place_holder_create(Xv_opaque);
	virtual Xv_opaque	mouse_virtualYposition_create(Xv_opaque);
	virtual Xv_opaque	const_message_virtualYposition_place_holder_create(Xv_opaque);
	virtual Xv_opaque	geolab_canvas_create(Xv_opaque);

	/*
	 * This was added by me...
	 */
     
	World *world;
	virtual World *geolab_world_create(Xv_opaque);
};

class geolab_popup_color_settings_objects {

public:
	Xv_opaque	popup_color_settings;
	Xv_opaque	controls_color_settings;
	Xv_opaque	setting_color;
	Xv_opaque	setting_foreback;
	Xv_opaque	button_color_apply_to_selected;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_color_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_color_settings_create(Xv_opaque);
	virtual Xv_opaque	setting_color_create(Xv_opaque);
	virtual Xv_opaque	setting_foreback_create(Xv_opaque);
	virtual Xv_opaque	button_color_apply_to_selected_create(Xv_opaque);
};

class geolab_popup_zoom_settings_objects {

public:
	Xv_opaque	popup_zoom_settings;
	Xv_opaque	controls_zoom_settings;
	Xv_opaque	button_zoom_reset;
	Xv_opaque	button_zoom_in;
	Xv_opaque	button_zoom_out;
	Xv_opaque	setting_zoom_center;
	Xv_opaque	setting_zoom_stack;
	Xv_opaque	slider_zoom_factor;
	Xv_opaque	slider_glass1_factor;
	Xv_opaque	slider_glass2_factor;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_zoom_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_zoom_settings_create(Xv_opaque);
	virtual Xv_opaque	button_zoom_reset_create(Xv_opaque);
	virtual Xv_opaque	button_zoom_in_create(Xv_opaque);
	virtual Xv_opaque	button_zoom_out_create(Xv_opaque);
	virtual Xv_opaque	setting_zoom_center_create(Xv_opaque);
	virtual Xv_opaque	setting_zoom_stack_create(Xv_opaque);
	virtual Xv_opaque	slider_zoom_factor_create(Xv_opaque);
	virtual Xv_opaque	slider_glass1_factor_create(Xv_opaque);
	virtual Xv_opaque	slider_glass2_factor_create(Xv_opaque);
};

class geolab_popup_line_settings_objects {

public:
	Xv_opaque	popup_line_settings;
	Xv_opaque	controls_line_settings;
	Xv_opaque	setting_line_width;
	Xv_opaque	setting_line_style;
	Xv_opaque	button_line_settings_apply_to_selected;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_line_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_line_settings_create(Xv_opaque);
	virtual Xv_opaque	setting_line_width_create(Xv_opaque);
	virtual Xv_opaque	setting_line_style_create(Xv_opaque);
	virtual Xv_opaque	button_line_settings_apply_to_selected_create(Xv_opaque);
};

class geolab_popup_random_points_settings_objects {

public:
	Xv_opaque	popup_random_points_settings;
	Xv_opaque	controls_random_points_settings;
	Xv_opaque	setting_all_region;
	Xv_opaque	setting_discard_input_random_points;
	Xv_opaque	setting_unselect_input_random_points;
	Xv_opaque	setting_points_selected_random_points;
	Xv_opaque	const_message_random_points;
	Xv_opaque	slider_scale_region;
	Xv_opaque	slider_number_points_region;
	Xv_opaque	const_message_random_points_timeout;
	Xv_opaque	slider_random_points_timeout;
	Xv_opaque	button_random_points_go;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_random_points_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_random_points_settings_create(Xv_opaque);
	virtual Xv_opaque	setting_all_region_create(Xv_opaque);
	virtual Xv_opaque	setting_discard_input_random_points_create(Xv_opaque);
	virtual Xv_opaque	setting_unselect_input_random_points_create(Xv_opaque);
	virtual Xv_opaque	setting_points_selected_random_points_create(Xv_opaque);
	virtual Xv_opaque	const_message_random_points_create(Xv_opaque);
	virtual Xv_opaque	slider_scale_region_create(Xv_opaque);
	virtual Xv_opaque	slider_number_points_region_create(Xv_opaque);
	virtual Xv_opaque	const_message_random_points_timeout_create(Xv_opaque);
	virtual Xv_opaque	slider_random_points_timeout_create(Xv_opaque);
	virtual Xv_opaque	button_random_points_go_create(Xv_opaque);
};

class geolab_popup_random_cover_settings_objects {

public:
	Xv_opaque	popup_random_cover_settings;
	Xv_opaque	controls_random_cover_settings;
	Xv_opaque	setting_discard_input_cover;
	Xv_opaque	setting_unselect_input_cover;
	Xv_opaque	setting_points_selected_cover;
	Xv_opaque	const_message_random_cover;
	Xv_opaque	slider_scale_cover;
	Xv_opaque	slider_number_points_cover;
	Xv_opaque	const_message_random_cover_timeout;
	Xv_opaque	slider_random_cover_timeout;
	Xv_opaque	button_random_cover_go;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_random_cover_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_random_cover_settings_create(Xv_opaque);
	virtual Xv_opaque	setting_discard_input_cover_create(Xv_opaque);
	virtual Xv_opaque	setting_unselect_input_cover_create(Xv_opaque);
	virtual Xv_opaque	setting_points_selected_cover_create(Xv_opaque);
	virtual Xv_opaque	const_message_random_cover_create(Xv_opaque);
	virtual Xv_opaque	slider_scale_cover_create(Xv_opaque);
	virtual Xv_opaque	slider_number_points_cover_create(Xv_opaque);
	virtual Xv_opaque	const_message_random_cover_timeout_create(Xv_opaque);
	virtual Xv_opaque	slider_random_cover_timeout_create(Xv_opaque);
	virtual Xv_opaque	button_random_cover_go_create(Xv_opaque);
};

class geolab_popup_animation_settings_objects {

public:
	Xv_opaque	popup_animation_settings;
	Xv_opaque	controls_animation_settings;
	Xv_opaque	setting_animation_on_off;
	Xv_opaque	const_message_depth;
	Xv_opaque	slider_animation_depth;
	Xv_opaque	textfield_animation_settings;
	Xv_opaque	const_message_animation_frame_control;
	Xv_opaque	button_animation_settings_pause_continue;
	Xv_opaque	button_animation_settings_step;
	Xv_opaque	button_animation_settings_fast_forward;
	Xv_opaque	const_message_animation_frame_delay;
	Xv_opaque	slider_animation_frame_delay;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_animation_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_animation_settings_create(Xv_opaque);
	virtual Xv_opaque	setting_animation_on_off_create(Xv_opaque);
	virtual Xv_opaque	const_message_depth_create(Xv_opaque);
	virtual Xv_opaque	slider_animation_depth_create(Xv_opaque);
	virtual Xv_opaque	textfield_animation_settings_create(Xv_opaque);
	virtual Xv_opaque	const_message_animation_frame_control_create(Xv_opaque);
	virtual Xv_opaque	button_animation_settings_pause_continue_create(Xv_opaque);
	virtual Xv_opaque	button_animation_settings_step_create(Xv_opaque);
	virtual Xv_opaque	button_animation_settings_fast_forward_create(Xv_opaque);
	virtual Xv_opaque	const_message_animation_frame_delay_create(Xv_opaque);
	virtual Xv_opaque	slider_animation_frame_delay_create(Xv_opaque);
};

class geolab_popup_random_polygon_settings_objects {

public:
	Xv_opaque	popup_random_polygon_settings;
	Xv_opaque	controls_random_polygon_settings;
	Xv_opaque	setting_random_polygon_discard_input;
	Xv_opaque	setting_polygon_type;
	Xv_opaque	setting_random_polygon_unselect_input;
	Xv_opaque	setting_random_polygon_selected;
	Xv_opaque	const_message_random_polygon_timeout;
	Xv_opaque	slider_random_polygon_timeout;
	Xv_opaque	button_random_polygon_go;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_random_polygon_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_random_polygon_settings_create(Xv_opaque);
	virtual Xv_opaque	setting_random_polygon_discard_input_create(Xv_opaque);
	virtual Xv_opaque	setting_polygon_type_create(Xv_opaque);
	virtual Xv_opaque	setting_random_polygon_unselect_input_create(Xv_opaque);
	virtual Xv_opaque	setting_random_polygon_selected_create(Xv_opaque);
	virtual Xv_opaque	const_message_random_polygon_timeout_create(Xv_opaque);
	virtual Xv_opaque	slider_random_polygon_timeout_create(Xv_opaque);
	virtual Xv_opaque	button_random_polygon_go_create(Xv_opaque);
};

class geolab_popup_color_settings_bw_objects {

public:
	Xv_opaque	popup_color_settings_bw;
	Xv_opaque	controls_color_settings_bw;
	Xv_opaque	const_message_color_settings_bw1;
	Xv_opaque	const_message_color_settings_bw2;
	Xv_opaque	const_message_color_settings_bw3;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_color_settings_bw_create(Xv_opaque);
	virtual Xv_opaque	controls_color_settings_bw_create(Xv_opaque);
	virtual Xv_opaque	const_message_color_settings_bw1_create(Xv_opaque);
	virtual Xv_opaque	const_message_color_settings_bw2_create(Xv_opaque);
	virtual Xv_opaque	const_message_color_settings_bw3_create(Xv_opaque);
};

class geolab_popup_algorithms_settings_objects {

public:
	Xv_opaque	popup_algorithms_settings;
	Xv_opaque	controls_algorithms_settings;
	Xv_opaque	const_message_algorithms_settings_generic_calls;
	Xv_opaque	setting_algorithms_discard_input;
	Xv_opaque	setting_algorithms_unselect_input;
	Xv_opaque	setting_algorithms_output_selected;
	Xv_opaque	const_message_algorithms_settings_dynamic_calls;
	Xv_opaque	setting_algorithms_discard_output;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_algorithms_settings_create(Xv_opaque);
	virtual Xv_opaque	controls_algorithms_settings_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_settings_generic_calls_create(Xv_opaque);
	virtual Xv_opaque	setting_algorithms_discard_input_create(Xv_opaque);
	virtual Xv_opaque	setting_algorithms_unselect_input_create(Xv_opaque);
	virtual Xv_opaque	setting_algorithms_output_selected_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_settings_dynamic_calls_create(Xv_opaque);
	virtual Xv_opaque	setting_algorithms_discard_output_create(Xv_opaque);
};

class geolab_popup_algorithms_statistics_objects {

public:
	Xv_opaque	popup_algorithms_statistics;
	Xv_opaque	controls_algorithms_statistics;
	Xv_opaque	textfield_algorithms_statistics_current;
	Xv_opaque	const_message_algorithms_statistics_real;
	Xv_opaque	const_message_algorithms_statistics_virtual;
	Xv_opaque	const_message_algorithms_statistics_time1;
	Xv_opaque	const_message_algorithms_statistics_real_place_holder;
	Xv_opaque	const_message_algorithms_statistics_virtual_place_holder;
	Xv_opaque	const_message_algorithms_statistics_time2;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_algorithms_statistics_create(Xv_opaque);
	virtual Xv_opaque	controls_algorithms_statistics_create(Xv_opaque);
	virtual Xv_opaque	textfield_algorithms_statistics_current_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_statistics_real_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_statistics_virtual_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_statistics_time1_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_statistics_real_place_holder_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_statistics_virtual_place_holder_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_statistics_time2_create(Xv_opaque);
};

class geolab_popup_algorithms_hackers_dream_objects {

public:
	Xv_opaque	popup_algorithms_hackers_dream;
	Xv_opaque	controls_algorithms_hackers_dream;
	Xv_opaque	setting_algorithms_dump_heap;
	Xv_opaque	textfield_algorihtms_hackers_dream;
	Xv_opaque	const_message_algorithms_hackers_dream_memory;
	Xv_opaque	const_message_algorithms_hackers_dream_total;
	Xv_opaque	const_message_algorithms_hackers_dream_total_place_holder;
	Xv_opaque	const_message_algorithms_hackers_dream_allocated;
	Xv_opaque	const_message_algorithms_hackers_dream_allocated_place_holder;
	Xv_opaque	const_message_algorithms_hackers_dream_free;
	Xv_opaque	const_message_algorithms_hackers_dream_free_place_holder;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_algorithms_hackers_dream_create(Xv_opaque);
	virtual Xv_opaque	controls_algorithms_hackers_dream_create(Xv_opaque);
	virtual Xv_opaque	setting_algorithms_dump_heap_create(Xv_opaque);
	virtual Xv_opaque	textfield_algorihtms_hackers_dream_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_memory_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_total_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_total_place_holder_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_allocated_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_allocated_place_holder_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_free_create(Xv_opaque);
	virtual Xv_opaque	const_message_algorithms_hackers_dream_free_place_holder_create(Xv_opaque);
};

class geolab_popup_edit_string_objects {

public:
	Xv_opaque	popup_edit_string;
	Xv_opaque	controls_edit_string;
	Xv_opaque	textfield_edit_string;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_edit_string_create(Xv_opaque);
	virtual Xv_opaque	controls_edit_string_create(Xv_opaque);
	virtual Xv_opaque	textfield_edit_string_create(Xv_opaque);
};

class geolab_popup_object_attributes_objects {

public:
	Xv_opaque	popup_object_attributes;
	Xv_opaque	control_object_attributes;
	Xv_opaque	setting_object_attributes_deletable;
	Xv_opaque	setting_object_attributes_line_width;
	Xv_opaque	setting_object_attributes_line_style;
	Xv_opaque	setting_object_attributes_glue;
	Xv_opaque	setting_object_attributes_handles;
	Xv_opaque	setting_object_attributes_foreground_color;
	Xv_opaque	setting_object_attributes_background_color;
	Xv_opaque	message_object_attributes;
	Xv_opaque	setting_object_attributes_increment;
	Xv_opaque	textfield_object_attributes_string;
	Xv_opaque	textfield_object_attributes_increment;
	Xv_opaque	button_object_attributes_apply_to_selected;
	Xv_opaque	button_object_attributes_set_default;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_object_attributes_create(Xv_opaque);
	virtual Xv_opaque	control_object_attributes_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_deletable_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_line_width_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_line_style_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_glue_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_handles_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_foreground_color_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_background_color_create(Xv_opaque);
	virtual Xv_opaque	message_object_attributes_create(Xv_opaque);
	virtual Xv_opaque	setting_object_attributes_increment_create(Xv_opaque);
	virtual Xv_opaque	textfield_object_attributes_string_create(Xv_opaque);
	virtual Xv_opaque	textfield_object_attributes_increment_create(Xv_opaque);
	virtual Xv_opaque	button_object_attributes_apply_to_selected_create(Xv_opaque);
	virtual Xv_opaque	button_object_attributes_set_default_create(Xv_opaque);
};

class geolab_popup_compose_objects {

public:
	Xv_opaque	popup_compose;
	Xv_opaque	controls_compose;
	Xv_opaque	button_compose_start;
	Xv_opaque	button_compose_stop;
	Xv_opaque	button_compose_play;
	Xv_opaque	const_message_compose_1;
	Xv_opaque	const_message_compose_2;
	Xv_opaque	const_message_compose_3;
	Xv_opaque	const_message_compose_4;

	virtual void	objects_initialize(Xv_opaque);

	virtual Xv_opaque	popup_compose_create(Xv_opaque);
	virtual Xv_opaque	controls_compose_create(Xv_opaque);
	virtual Xv_opaque	button_compose_start_create(Xv_opaque);
	virtual Xv_opaque	button_compose_stop_create(Xv_opaque);
	virtual Xv_opaque	button_compose_play_create(Xv_opaque);
	virtual Xv_opaque	const_message_compose_1_create(Xv_opaque);
	virtual Xv_opaque	const_message_compose_2_create(Xv_opaque);
	virtual Xv_opaque	const_message_compose_3_create(Xv_opaque);
	virtual Xv_opaque	const_message_compose_4_create(Xv_opaque);
};

#endif ~_GEOLAB_UI_DEFINED;








