/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * global.h - definicoes globais ao GeoLab.
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    26.09.91  18:25 	Welson R. Jacometti  	Arquivo criado
 *
 */
 
#ifndef _GLOBAL_DEFINED
#define _GLOBAL_DEFINED

#define EXPORT extern

#define ERROR  	0
#define SUCCESS	1

#ifndef PI
#define PI	3.141592653589793
#endif

#define EPSLON	1e-4

#define	MENU_FILENAME	".geolab-menu"
#define MENU_DIR	"GEOLAB_MENU"
#define ALGORITHMS_DIR  "GEOLAB_ALGORITHMS"

typedef void* address;
typedef unsigned short icon_bits;

typedef int bool;
EXPORT const bool true;
EXPORT const bool false;

enum DrawMode {NoMode, CopyMode, XorMode};
enum CompType {Less = -1, Equal = 0, Greater = 1};
enum SideType {Left = -1, Colinear = 0, Right = 1};
enum inCircleType {Inside = -1, Boundary = 0, Outside = 1};
enum IntersectType {Intersect, Tangent, NoIntersection, JustOneIntersection};
enum Int_Mode {LeftButton, MiddleButton};
enum AlgorithmType {ALG, EFM, EOM};

#endif ~_GLOBAL_DEFINED
