/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 * intersections.h - algoritmos para problemas de intersecao. Sao considerados
 *                   elementos de entrada sendo segmentos, raios e retas.
 * 
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    24.04.92  09:30 	Welson R. Jacometti  	Arquivo criado
 *
 */

#ifndef _INTERSECTIONS_DEFINED
#define _INTERSECTIONS_DEFINED
 
#include "External.h"		// obrigatorio a todo modulo externo
#include "Algorithm.h"
#include "Point2D.h"
#include "Segment2D.h"
#include "Ray2D.h"
#include "Line2D.h"

#ifndef _Point2D_ptr_list
#define _Point2D_ptr_list
declare(list,Point2D_ptr)
#endif ~_Point2D_ptr_list;

#ifndef _Segment2D_ptr_list
#define _Segment2D_ptr_list
declare(list,Segment2D_ptr)
#endif ~_Segment2D_ptr_list;

#ifndef _Ray2D_ptr_list
#define _Ray2D_ptr_list
declare(list,Ray2D_ptr)
#endif ~_Ray2D_ptr_list;

#ifndef _Line2D_ptr_list
#define _Line2D_ptr_list
declare(list,Line2D_ptr)
#endif ~_Line2D_ptr_list;

// brute force
int all_intersections_counting_bf(list(Segment2D_ptr) &segments, World *w = 0, int animation_depth = 0, int reference_depth = 0);
list(Point2D_ptr) all_intersections_report_bf(list(Segment2D_ptr) &segments, World *w = 0, int animation_depth = 0, int reference_depth= 0);

int all_intersections_rays_counting_bf(list(Ray2D_ptr) &rays, World *w = 0, int animation_depth = 0, int reference_depth = 0);
list(Point2D_ptr) all_intersections_rays_report_bf(list(Ray2D_ptr) &rays, World *w = 0, int animation_depth = 0, int reference_depth= 0);

int all_intersections_lines_counting_bf(list(Line2D_ptr) &lines, World *w = 0, int animation_depth = 0, int reference_depth = 0);
list(Point2D_ptr) all_intersections_lines_report_bf(list(Line2D_ptr) &lines, World *w = 0, int animation_depth = 0, int reference_depth= 0);

#endif ~_INTERSECTIONS_DEFINED;








