/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * line_settings.C
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    12.12.91  08:45 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "line_settings.h"
#include <xview/xview.h>

// Agora, default para LINE_WIDTH e LINE_STYLE s~ao setados
// em geolab_stubs.C (dependem de Default_Obj_Attributes).
// Gon, 24/08/92

int LINE_WIDTH;
int LINE_STYLE;

int get_line_width_from_index(int index) {
    return index*2;
}
					  
int get_index_from_line_width(int lw) {
    return lw/2;
}
				     
int get_line_style_from_index(int index) {
    switch (index) {
      case SOLID:
        return LineSolid;
      case DASHED:
        return LineOnOffDash;
      case DOUBLEDASHED:
        return LineDoubleDash;
    }
    // error...
    return -1;
}

    
int get_index_from_line_style(int ls) {
    switch (ls) {
      case LineSolid:
        return SOLID;
      case LineOnOffDash:
        return DASHED;
      case LineDoubleDash:
        return DOUBLEDASHED;
    }
    // error...
    return -1;
}





