/*
    Copyright (C) 1992-1994
                    Welson R. Jacometti

    All rights reserved.

    This program is  free software; you can redistribute unmodified
    versions of it as long as you do not  profit from that, neither
    by selling it nor  by   including it  with other products   for
    sale.  This copyright  notice  must  remain in all  distributed
    copies.

    You are  allowed to modify your  personal copy  of this program
    (as long as you do not distribute any changed versions).

    You may,  of course, distribute  along with it, your own source
    code or libraries of algorithms that run under GeoLab.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

    If you must contact the authors, you may write to:
                     geolab-request@dcc.unicamp.br
*/

/*
 *
 * scroll.C - modulo de execucao de scroll. 
 *
 *
 *    	Data	Hora  	Nome     		Modificacao/Motivo
 *
 *    08.10.91  21:25 	Welson R. Jacometti  	Arquivo criado
 *
 */

#include "scroll.h"

/*
 * scroll_events() - trata eventos ativando funcoes de scroll.
 *
 * Button LEFT DOWN - scroll_start()
 *        LEFT UP   - scroll_end()
 *        LOC_DRAG  - scroll()
 */
 
bool scroll_events(World *world, Xv_Window, Event *event) {
    static int x0, y0, x, y;
    static GC gc;
    static int first = true;
    
    if (first) {
      XGCValues v;
      v.foreground = (unsigned long)xv_get(world->get_canvas(), WIN_BACKGROUND_COLOR);
      gc = world->CreateGC(GCForeground, v);
      first = false;
    }
    
    switch (event_action(event)) {
      case ACTION_SELECT:		// LEFT BUTTON
        if (event_is_down(event)) {
          x0 = event_x(event);
          y0 = event_y(event);
          x = y = 0;
          world->pscroll_begin(gc);
        }
        else {
          world->pscroll_end(x, y);
          world->call_repaint_proc();
        }
        break;
        
      case LOC_DRAG:
        x = event_x(event) - x0;
        y = event_y(event) - y0;
        world->pscroll_same_size(gc, x, y);
        break;
    }
    
    return false;
}          




